battle:
	;d'abord dfinir si c'est un combat contre un pokmon sauvage, un dresseur voire un autre joueur (par link)
	bcall _grbufclr
battle_type = $+1	;	0 = pokmon sauvage
	ld a,0
	or a
	ret nz
	call generate_wild_pokemon

battle_intro:
	bcall _grbufclr
	call battle_draw_player_back
	call battle_draw_frame
	ld hl,opponent_pokemon_stats
	ld (battle_current_opponent_pokemon_adress),hl
	call battle_wild_pokemon_intro

battle_start:
	call battle_player_pokemon_intro	; /!\ cette routine se termine par un fade_out
	call battle_draw_menu
	call fade_in

battle_loop:
	call battle_menu
	call battle_wild_pokemon_ai
	jr battle_loop

;- Routine du menu principal des combats --------------------------------------------------------------------------
battle_menu:
	call battle_draw_menu
	ld hl,battle_menu_valid
	ld (menu_valid_addr),hl
	ld hl,menu_handle
	ld (menu_cancel_addr),hl
	ld hl,menu_oncursor_nothing
	ld (menu_oncursor_call_addr),hl
	ld hl,menu_down
	ld (menu_down_addr),hl
	ld hl,menu_up
	ld (menu_up_addr),hl
	ld hl,battle_menu_left
	ld (menu_left_addr),hl
	ld hl,battle_menu_right
	ld (menu_right_addr),hl
	jp menu_handle

battle_draw_menu:
	bcall _cleargbuf
	call battle_draw_screen
	xor a
	ld (menu_cursor),a
	ld (_v_mode),a
	ld hl,$3206
	ld (pencol),hl
	ld hl,battle_pokemon_str_fight
	call _vputs_ml
	ld hl,$3236
	ld (pencol),hl
	ld hl,battle_pokemon_str_pokemon
	call _vputs_ml
	ld a,1
	ld (menu_max_option),a
	inc a
	ld (menu_cursor_x),a
	add a,48
	ld (menu_cursor_y),a
	jp draw_menu_cursor2

battle_menu_valid:
	ld a,(menu_cursor)
	or a
	jp nz,battle_menu_valid_second_line
	ld a,(menu_cursor_x)
	cp 2
	jr z,battle_menu_fight

battle_menu_pokemon:
	ret

battle_menu_run:
	pop af
	ret

battle_menu_pack:
	ret

battle_menu_down:
	ld a,(menu_cursor_x)
	cp 50
	jr z,battle_menu_down_verif
	jp menu_down

battle_menu_down_verif:
	ld a,(battle_menu_fight_choices)
	cp 4
	ret nz
	jp menu_down

battle_menu_left:
	ld a,(menu_cursor_x)
	cp 2
	ret z
	sub 48
	ld (menu_cursor_x),a
	jp draw_menu_cursor

battle_menu_right:
	ld a,(menu_cursor_x)
	cp 50
	ret z
	add a,48
	ld (menu_cursor_x),a
	jp draw_menu_cursor
;------------------------------------------------------------------------------------------------------------------

;- Routine du menu des attaques -----------------------------------------------------------------------------------
battle_menu_fight:
	xor a
	ld (battle_menu_fight_choices),a
	call battle_draw_frame
	ld hl,(battle_current_player_pokemon_adress)
	ld de,pokemon_attacks-pokemon_stats
	add hl,de
	ld a,(hl)
	ld (first_attack_id),a
	ld b,4

battle_menu_fight_loop:
	push bc
	push hl
	ld de,$3206
	ld (pencol),de
	ld a,b
	cp 1
	call z,battle_menu_fight_disp_fourth_attack
	cp 2
	call z,battle_menu_fight_disp_third_attack
	cp 3
	call z,battle_menu_fight_disp_second_attack
	call battle_menu_fight_disp_attack
	ld a,(battle_menu_fight_choices)
	inc a
	ld (battle_menu_fight_choices),a
	pop hl
	pop bc
	inc hl
	inc hl
	inc hl
	ld a,(hl)
	or a
	jr z,battle_menu_fight_skip
	djnz battle_menu_fight_loop

battle_menu_fight_skip:
	ld a,(battle_menu_fight_choices)
	sub 2
	jp p,battle_menu_fight_skip2
	inc a

battle_menu_fight_skip2:
	ld (menu_max_option),a
	ld hl,battle_menu_fight_valid
	ld (menu_valid_addr),hl
	ld hl,battle_menu
	ld (menu_cancel_addr),hl
	ld hl,battle_menu_fight_disp_pp
	ld (menu_oncursor_call_addr),hl
	ld hl,battle_menu_down
	ld (menu_down_addr),hl
	ld hl,menu_up
	ld (menu_up_addr),hl
	ld hl,battle_menu_left
	ld (menu_left_addr),hl
	ld hl,battle_menu_fight_right
	ld (menu_right_addr),hl
	call draw_menu_cursor
	jp menu_handle

battle_menu_fight_disp_second_attack:
	push af
	ld a,(hl)
	ld (second_attack_id),a
	ld de,$3236
	ld (pencol),de
	pop af
	ret

battle_menu_fight_disp_third_attack:
	push af
	ld a,(hl)
	ld (third_attack_id),a
	ld de,$3806
	ld (pencol),de
	pop af
	ret

battle_menu_fight_disp_fourth_attack:
	push af
	ld a,(hl)
	ld (fourth_attack_id),a
	ld de,$3836
	ld (pencol),de
	pop af
	ret

battle_menu_fight_disp_attack:
	call find_attack
	ld de,attack_name-attack_data
	add hl,de
	bcall _vputs
	ret

battle_menu_fight_valid:
	; vrifier s'il y a assez de PP
current_attack = $+1
	ld c,0
	ld hl,(battle_current_player_pokemon_adress)
	call find_pokemon_attack
	inc hl
	ld a,(hl)
	or a
	jp z,menu_handle	; pas assez de PP
	dec (hl)	; si c'est bon on decrmente
	call battle_draw_frame
	ld hl,(battle_current_player_pokemon_adress)
	ld a,(current_attack)
	call battle_disp_attack	; dire "machin lance truc"
	ld de,(battle_current_opponent_pokemon_adress)
	push de
	call battle_check_attack_effectivity	; vrifier en fonction des types si c'est super efficace
	pop de
	push de
	ld hl,(battle_current_player_pokemon_adress)
	call calculate_damages	; calculer les dgts
	pop hl
	push af
	push hl
	bcall _grbufclr
	call battle_draw_screen
	pop hl
	push hl
	call battle_opponent_pokemon_blink_sprite
	pop hl
	pop af
	ld b,a

battle_menu_damages_loop:
	push bc
	push hl
	call battle_reset_opponent_pokemon_health_bar_and_hp
	pop hl
	push hl
	inc hl
	inc hl
	dec (hl)
	ld a,(hl)
	or a
	push af
	call battle_disp_opponent_pokemon_hp
	pop af
	pop hl
	push hl
	push af
	call battle_draw_opponent_pokemon_health_bar
	call ionFastCopy
	pop af
	pop hl
	pop bc
	jp z,battle_handle_pokemon_ko
	djnz battle_menu_damages_loop
	ld a,(CE)
	cp 1
	call nz,battle_disp_effectivity

	; vrifier les changements d'tats
	; vrifier si le pokmon est KO
	; etc...
	; calculer l'exp
	; si c'est contre dresseur : grer le fric
	;  la fin il faudra penser  retirer l'tat confus aux pokmons concerns !!!!!!!!!!!!!
	ret

battle_menu_fight_disp_pp:
	ld bc,$0960
	ld de,$0029
	call draw_frame
	ld a,(menu_cursor)
	or a
	jp nz,battle_menu_fight_second_line
	ld a,(menu_cursor_x)
	cp 2
	jr nz,battle_menu_fight_second_attack
first_attack_id = $+1
	ld a,0
	jr battle_menu_fight_next

battle_menu_fight_second_attack:
second_attack_id = $+1
	ld a,0
	jr battle_menu_fight_next

battle_menu_fight_second_line:
	ld a,(menu_cursor_x)
	cp 2
	jr nz,battle_menu_fight_fourth_attack
third_attack_id = $+1
	ld a,0
	jr battle_menu_fight_next

battle_menu_fight_fourth_attack:
fourth_attack_id = $+1
	ld a,0

battle_menu_fight_next:
	ld (current_attack),a
	push af
	call find_attack_a
	call find_type
	ld a,(hl)	; ce qui suit c'est pour rcuprer le nom du type (j'en ferais peut tre une routine pour les autres menus)
	inc hl
	ld d,0
	ld e,a
	add hl,de
	ld a,(hl)
	inc hl
	ld d,0
	ld e,a
	add hl,de
	ld de,$2a02
	ld (pencol),de
	bcall _vputs
	pop af
	ld c,a
	ld hl,(battle_current_player_pokemon_adress)
	call find_pokemon_attack
	inc hl
	push hl
	ld a,(hl)
	ld de,$2a4b
	ld (pencol),de
	call _vdispa
	ld de,$2a53
	ld (pencol),de
	ld a,$2f
	bcall _vputmap
	pop hl
	inc hl
	ld a,(hl)
	ld de,$2a57
	ld (pencol),de
	call _vdispa
	jp ionFastCopy

battle_menu_fight_right:
battle_menu_fight_choices = $+1
	ld a,0
	dec a
	or a
	ret z

	ld a,(menu_cursor)
	cp 1
	jr z,battle_menu_fight_right_verif

battle_menu_fight_right_next:
	ld a,(menu_cursor_x)
	cp 50
	ret z
	add a,48
	ld (menu_cursor_x),a
	jp draw_menu_cursor

battle_menu_fight_right_verif:
	ld a,(battle_menu_fight_choices)
	cp 4
	ret nz
	jr battle_menu_fight_right_next

battle_menu_valid_second_line:
	ld a,(menu_cursor_x)
	cp 2
	jp z,battle_menu_pack

;- Routine d'introduction des pokmons sauvages -------------------------------------------------------------------
battle_wild_pokemon_intro:
	call find_pokemon_data
	push hl
	ld a,(hl)
	ld d,0
	ld e,a
	add hl,de	; on saute son nom pour avoir son sprite
	push hl
	pop ix
	push ix
	xor a
	ld bc,$1a05
	ld l,0
	push af
	push bc
	push hl
	push ix
	call ionLargeSprite
	call ionFastCopy
	pop ix
	pop hl
	pop bc
	pop af
	call ionLargeSprite
	call fade_in
	pop ix
	ld b,56

battle_wild_pokemon_intro_loop:
	push bc
	ld a,56
	sub b
	ld bc,$1a05
	ld l,0
	push af
	push bc
	push hl
	push ix
	call ionLargeSprite
	call ionFastCopy
	pop ix
	pop hl
	pop bc
	pop af
	push ix
	call ionLargeSprite
	pop ix
	pop bc
	djnz battle_wild_pokemon_intro_loop
	ld a,56
	sub b
	ld bc,$1a05
	ld l,0
	call ionLargeSprite
	call battle_draw_frame
	ld de,$3202
	ld (pencol),de
	ld hl,battle_wild_pokemon_intro1
	call _v_type
	pop hl
	inc hl
	call _v_type
	ld de,$3802
	ld (pencol),de
	ld hl,battle_wild_pokemon_intro2
	call _v_type
	jp _v_disp_pause
;------------------------------------------------------------------------------------------------------------------

;- Routine d'introduction des pokmons du joueur ------------------------------------------------------------------
battle_player_pokemon_intro:
	call battle_search_next_player_pokemon_alive	; il faut d'abord vrifier quel est le premier pokmon en vie sur les 6 qu'on porte avec nous
	ret nz	; s'il n'y en a pas : game over
	push hl
	call battle_draw_frame
	ld de,$3202
	ld (pencol),de
	ld hl,battle_player_pokemon_intro1
	call _v_type
	ld de,$3802
	ld (pencol),de
	pop hl
	call find_pokemon_data
	inc hl
	call _v_type
	ld hl,battle_player_pokemon_intro2
	call _v_type
	call _v_disp_pause
	call fade_out
	jr battle_draw_player_back
;------------------------------------------------------------------------------------------------------------------

;- Routine qui se charge de recherche le prochain pokmon en vie sur les 6 que porte le joueur --------------------
battle_search_next_player_pokemon_alive:	; output : z:pokmon found ; nz:all pokmon dead ; hl = pokmon datas
	ld hl,player_pokemons
	ld b,6

battle_search_next_player_pokemon_alive_loop:
	push bc
	push hl
	ld a,(hl)
	or a	; vrifier qu'il y ait bien un pokmon dans l'emplacement
	jp z,battle_search_next_player_pokemon_alive_skip
	pop hl
	push hl
	call find_pokemon_stats
	inc hl
	inc hl	; vrifier s'il est en vie
	ld a,(hl)
	or a
	jp nz,battle_search_next_player_pokemon_alive_ok

battle_search_next_player_pokemon_alive_skip:
	pop hl
	inc hl
	pop bc
	djnz battle_search_next_player_pokemon_alive_loop
	or $80	; reset zero flag
	ret

battle_search_next_player_pokemon_alive_ok:
	dec hl
	dec hl
	ld (battle_current_player_pokemon_adress),hl
	pop af
	pop af
	xor a	; set zero flag
	ret
;------------------------------------------------------------------------------------------------------------------

;- Routines d'affichages de diffrentes choses durant les combats -------------------------------------------------
battle_draw_player_back:
player_gender = $+1
	ld a,0
	or a
	jr z,battle_draw_player_man_back
	ld ix,player_woman_back
	jr battle_draw_player_next

battle_draw_player_man_back:
	ld ix,player_man_back

battle_draw_player_next:
	xor a
	ld bc,$1a04
	ld l,23
	jp ionLargeSprite

battle_draw_screen:
	call battle_draw_frame
battle_current_opponent_pokemon_adress = $+1
	ld hl,0
	push hl
	call battle_draw_pokeball_if_already_captured	; On s'occupe d'abord d'afficher le cadre + les donnes du pokmon adverse
	pop hl
	push hl
	call find_pokemon_data
	push hl
	ld a,(hl)
	ld d,0
	ld e,a
	add hl,de
	push hl
	pop ix
	ld bc,$1a05
	ld a,56
	ld l,0
	call ionLargeSprite	; on affiche le sprite du pokmon adverse
	pop hl
	inc hl
	ld de,$0002
	ld (pencol),de
	bcall _vputs	; on crit son nom
	ld hl,battle_pokemon_str_lvl
	ld de,$0a01
	ld (pencol),de
	bcall _vputs
	pop hl
	push hl
	inc hl
	push hl
	ld a,(hl)
	call _vdispa	; on crit son niveau
	pop hl
	inc hl
	push hl
	call battle_disp_opponent_pokemon_hp
	pop hl
	inc hl
	inc hl
	call battle_draw_opponent_pokemon_state
	ld bc,$1007
	push bc
	ld a,1
	ld l,7
	ld ix,battle_bar
	push ix
	call ionLargeSprite	; on affiche sa barre de vie
	pop ix
	pop bc
	; Ensuite lorsque ce sera un dresseur : afficher ses pokballs
	call flip_sprite	; on la flip horizontalement
	ld a,39
	ld l,32
	call ionLargeSprite	; puis on l'affiche de notre ct
	pop hl
	call battle_draw_opponent_pokemon_health_bar
	;-------------------------------------------
	;  partie de l on ne s'occupe plus que de notre ct
	;-------------------------------------------
battle_current_player_pokemon_adress = $+1
	ld hl,0
	push hl
	call find_pokemon_data
	push hl
	ld a,(hl)
	ld d,0
	ld e,a
	add hl,de
	push hl
	pop ix
	ld bc,$1a05
	call flip_sprite
	xor a
	ld l,23
	call ionLargeSprite	; on affiche le sprite de notre pokmon
	pop hl
	inc hl
	ld de,$192c
	ld (pencol),de
	bcall _vputs	; le nom de notre pokmon
	ld hl,battle_pokemon_str_lvl
	ld de,$232b
	ld (pencol),de
	bcall _vputs
	pop hl
	push hl
	inc hl
	push hl
	ld a,(hl)
	call _vdispa	; son niveau
	pop hl
	inc hl
	push hl
	call battle_disp_player_pokemon_hp
	pop hl
	inc hl
	inc hl
	push hl
	call battle_draw_player_pokemon_state
	pop hl
	ld de,pokemon_exp-pokemon_state	; pour accder  son exprience (depuis l'tat)
	add hl,de
	call battle_draw_player_pokemon_experience_bar
	pop hl
	push hl
	call battle_draw_player_pokemon_health_bar
	call battle_draw_player_pokeballs
	pop hl
	ret

battle_player_pokemon_blink_sprite:	; hl=player pokemon stats
	call battle_blink_sprite

battle_player_pokemon_blink_sprite_loop:
	push bc
	push ix
	ld bc,$1a05
	call flip_sprite
	xor a
	ld l,23
	call ionLargeSprite
	call ionFastCopy
	ld b,battle_blink_sprite_speed
	call wait
	pop ix
	pop bc
	djnz battle_player_pokemon_blink_sprite_loop
	ret

battle_opponent_pokemon_blink_sprite:	; hl=opponent pokemon stats
	call battle_blink_sprite

battle_opponent_pokemon_blink_sprite_loop:
	push bc
	push ix
	ld bc,$1a05
	ld a,56
	ld l,0
	call ionLargeSprite
	call ionFastCopy
	ld b,battle_blink_sprite_speed
	call wait
	pop ix
	pop bc
	djnz battle_opponent_pokemon_blink_sprite_loop
	ret

battle_blink_sprite:
	call find_pokemon_data
	ld a,(hl)
	ld d,0
	ld e,a
	add hl,de
	push hl
	pop ix
	ld b,battle_blink_sprite_times*2	; must be even
	ret

battle_disp_player_pokemon_hp:	;	input : hl = player pokemon HP
	push hl
	ld de,$2342
	call battle_disp_pokemon_hp
	ld de,$234e
	jr battle_disp_pokemon_hpmax

battle_disp_opponent_pokemon_hp:
	push hl
	ld de,$0a18
	call battle_disp_pokemon_hp
	ld de,$0a24

battle_disp_pokemon_hpmax:
	ld (pencol),de
	ld a,$d1
	bcall _vputmap
	pop hl
	inc hl
	ld a,(hl)
	jp _vdispa

battle_disp_pokemon_hp:
	ld (pencol),de
	ld a,(hl)
	jp _vdispa

battle_draw_player_pokemon_state:	; input : hl = player pokemon state
	ld a,(hl)
	or a
	ret z
	push af
	ld bc,$060c
	ld de,$1e2a
	call rectangle_filled_white
	pop af
	call battle_draw_pokemon_state
	ld de,$2a1f
	ld (pencol),de
	bcall _vputs
	ret

battle_draw_opponent_pokemon_state:	; input : hl = opponent pokemon state
	ld a,(hl)
	or a
	ret z
	push af
	ld bc,$060c
	ld de,$3611
	call rectangle_filled_white
	pop af
	call battle_draw_pokemon_state
	ld de,$1136
	ld (pencol),de
	bcall _vputs
	ret

battle_draw_pokemon_state:
	ld hl,menu_pokemon_str_poison
	cp 2
	jr z,battle_draw_player_pokemon_state_sleep
	cp 3
	jr z,battle_draw_player_pokemon_state_para
	ret

battle_draw_player_pokemon_state_sleep:
	ld hl,menu_pokemon_str_sleep
	ret

battle_draw_player_pokemon_state_para:
	ld hl,menu_pokemon_str_para
	ret

battle_reset_player_pokemon_health_bar_and_hp:
	ld bc,$0132
	ld de,$2c21
	call rectangle_filled_white
	ld bc,$051b
	ld de,$4224
	jp rectangle_filled_white

battle_reset_opponent_pokemon_health_bar_and_hp:
	ld bc,$0132
	ld de,$0208
	call rectangle_filled_white
	ld bc,$051b
	ld de,$180b
	jp rectangle_filled_white

battle_draw_player_pokemon_health_bar:	; input : hl = player pokemon datas
	ld de,$2c21
	jr battle_draw_pokemon_health_bar

battle_draw_opponent_pokemon_health_bar:	; input : hl = opponent pokemon stats
	ld de,$0208

battle_draw_pokemon_health_bar:
	inc hl
	inc hl
	ld a,(hl)
	or a
	ret z
	ld a,50
	push de
	call calculate_proportionality
	pop de
	ld b,1
	ld c,a
	jp rectangle_filled_solid

battle_draw_player_pokemon_experience_bar:	; input : hl = pokemon experience
	ld a,(hl)
	or a
	ret z
	ld a,44
	call calculate_proportionality
	ld b,1
	ld c,a
	ld de,$312e
	jp rectangle_filled_solid

battle_draw_pokeball_if_already_captured:	; input : hl=id
	ld a,(hl)
	call is_already_captured
	ret nz
	ld a,4
	ld l,17
	ld b,4
	ld ix,pokeball_pokemon_alread_captured
	jp ionPutSprite

battle_draw_player_pokeballs:
	xor a
	ld (battle_draw_player_pokeballs_count),a
	ld hl,player_pokemons
	ld b,6

battle_draw_player_pokeballs_loop:
	ld a,(hl)
	or a
	jr z,battle_draw_player_pokeballs_skip
	push bc
	push hl
	call find_pokemon_stats
	ld ix,pokeball_pokemon_alive
	inc hl
	inc hl
	ld a,(hl)
	or a
	call z,battle_draw_player_pokeball_dead
	ld a,49
battle_draw_player_pokeballs_count = $+1
	ld c,0
	add a,c
	add a,c
	add a,c
	add a,c
	ld l,42
	ld b,3
	call ionPutSprite
	ld a,(battle_draw_player_pokeballs_count)
	inc a
	ld (battle_draw_player_pokeballs_count),a
	pop hl
	pop bc
	inc hl
	djnz battle_draw_player_pokeballs_loop
	ret

battle_draw_player_pokeball_dead:
	ld ix,pokeball_pokemon_dead
	ret

battle_draw_player_pokeballs_skip:
	inc hl
	djnz battle_draw_player_pokeballs_loop
	ret

battle_draw_frame:
	ld bc,$0f60
	ld de,$0031
	jp draw_frame

battle_disp_attack:	; input : hl=pokemon id, a=attack id ; output : hl=attack datas
	push af
	push hl
	call battle_draw_frame
	pop hl
	call find_pokemon_data
	inc hl
	ld de,$3202
	ld (pencol),de
	call _v_type
	ld de,$3802
	ld (pencol),de
	ld hl,battle_pokemon_str_attack
	call _v_type
	pop af
	call find_attack_a
	push hl
	ld d,0
	ld e,attack_name-attack_data
	add hl,de
	call _v_type
	call _v_disp_pause
	pop hl
	ret

battle_disp_effectivity:
	cp 3
	jr z,battle_disp_not_effective
	ld hl,battle_pokemon_str_super_effective
	jr battle_disp_effectivity_next

battle_disp_not_effective:
	ld hl,battle_pokemon_str_not_effective

battle_disp_effectivity_next:
	ld de,$3202
	ld (pencol),de
	ld a,1
	ld (_v_mode),a
	jp _vputs_ml
;------------------------------------------------------------------------------------------------------------------

;- Routine pour vrifier l'efficacit d'une attaque ---------------------------------------------------------------
battle_check_attack_effectivity:	; input : hl=attack type, de=opponent id
	ld a,1
	ld (CE),a
	push de
	call find_type	; vrifier en fonction des types si c'est super efficace
	pop de
	push hl
	ld a,(de)
	call find_pokemon_data_a
	ld d,0
	ld e,(hl)
	add hl,de
	ld e,pokemon_type-pokemon_data
	add hl,de
	ld e,(hl)
	pop hl
	ld a,(hl)
	or a	; aucune efficacit (pas de type sensible)
	jr z,battle_check_attack_super_effective_skip
	ld b,a
	call battle_check_attack_effectivity_loop
	jr z,battle_check_attack_super_effective

battle_check_attack_super_effective_skip:
	inc hl
	ld a,(hl)
	or a
	ret z
	ld b,a
	call battle_check_attack_effectivity_loop
	ret nz
	ld a,3
	ld (CE),a
	ret

battle_check_attack_super_effective:
	ld a,2
	ld (CE),a
	ret

battle_check_attack_effectivity_loop:
	inc hl
	ld a,(hl)
	cp e
	ret z
	djnz battle_check_attack_effectivity_loop
	or $80
	ret
;------------------------------------------------------------------------------------------------------------------

;- Routine qui se charge de grer la mort d'un pokmon ------------------------------------------------------------
battle_handle_pokemon_ko:
	pop af	; petit "hack" pour sortir de la boucle de combat
	jp _v_disp_pause	; dire "machin est mort" et grer la suite
;------------------------------------------------------------------------------------------------------------------

opponent_pokemon_stats:	; ID, lvl, PV, PVmax, state (0=normal; 1=poison; 2=sleep; 3=para), ATT, DEF, (Attack ID, PP, PPmax)*4
	.db 0

opponent_pokemon_stats_lvl:
	.db 0

opponent_pokemon_stats_hp:
	.db 0

opponent_pokemon_stats_hp_max:
	.db 0

opponent_pokemon_stats_state:
	.db 0

opponent_pokemon_stats_att:
	.db 0

opponent_pokemon_stats_def:
	.db 0

opponent_pokemon_stats_attacks:
	.db 0,0,0,0,0,0,0,0,0,0,0,0

opponent_pokemon_stats_length:
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

opponent_pokemon_lvl:	; en attendant de s'en servir
	.db 0